function [bw1, bw2, bw3,...
          f1,f2,f3,...
          F1,F2,F3,...
          F1inv,F2inv,F3inv] = fitKDE(X1, X2, X3)
% Group 1
        n1 = length(X1); 
        bw1= 0.9*min([std(X1) iqr(X1)/1.34])*n1^(-0.2);
        pd1 = fitdist(X1, 'Kernel', 'Kernel', 'normal',  'Bandwidth', bw1);
        f1 = @(t) pdf(pd1,t);
        F1 = @(t) cdf(pd1,t);
        F1inv = @(t) icdf(pd1,t);
% Group 2       
        if nargin > 1
            n2 = length(X2); 
            bw2= 0.9*min([std(X2) iqr(X2)/1.34])*n2^(-0.2);
            pd2 = fitdist(X2, 'Kernel', 'Kernel', 'normal',  'Bandwidth', bw2);
            f2 = @(t) pdf(pd2,t);
            F2 = @(t) cdf(pd2,t);
            F2inv = @(t) icdf(pd2,t);
        else 
            bw2 = NaN;
            f2 = @(t) NaN;
            F2 = @(t) NaN;
            F2inv = @(t) NaN;
        end 
% Group 3       
        if nargin > 2
            n3 = length(X3);
            bw3= 0.9*min([std(X3) iqr(X3)/1.34])*n3^(-0.2);
            pd3 = fitdist(X3, 'Kernel', 'Kernel', 'normal',  'Bandwidth', bw3);
            f3 = @(t) pdf(pd3,t);
            F3 = @(t) cdf(pd3,t);
            F3inv = @(t) icdf(pd3,t);
        else 
            bw3 = NaN;
            f3 = @(t) NaN;
            F3 = @(t) NaN;
            F3inv = @(t) NaN;
        end 
end

